;; palindromi.lsp
;; by MacMan 15/3/2003

;; Funzioni di servizio
;; Riporta l'ultimo elemento della lista
(defun ultimo (lista)
	(let ((prossimo (cdr lista)))		
		(if prossimo			;; se prossimo non  NIL...
			(ultimo prossimo)	;; allora devo riapplicare la funzione
			(car lista))))		;; altrimenti estraggo l'atomo dalla lista e lo restituisco

;; Riporta la lista escluso l'ultimo elemento
(defun primaparte (lista)
	(let ((risultato (list (car lista))))		;; qui costruisco il risultato per mezzo dell'append
		(if (cddr lista)						;; se nella lista ci sono almeno altri due atomi...
			(setq risultato (append risultato (primaparte (cdr lista)))))
		risultato))

;; Funzione principale
;; Riporta T se la stringa  palindroma, NIL altrimenti 
(defun palindroma (lista)
	(let (
		(primoatomo (car lista))
		(ultimoatomo (ultimo lista))
		(restolista (primaparte (cdr lista))))
		(if (not (or (null restolista) (null (cdr restolista))))	;; condizione di uscita dalla ricorsione
			(if (equal primoatomo ultimoatomo)						;; primo e ultimo sono uguali?
				(palindroma restolista)								;; se s, continuo la ricorsione
				NIL)												;; altrimenti, la lista non  palindroma, esco con NIL
			T)))	;; questo  l'"else" dell'if di riga 25. Abbiamo finito quindi usciamo restituendo T
			
;; That's all, folks!			
