;; Power.lsp by MacMan 16/7/2002
;; Funzioni che calcolano l'elevamento a potenza
;; (vd. esercizio 11 del TEs del 16/12/1998)

(format t "~%power.lsp by MacMan 16/7/2002~%")

; Versione ricorsiva
(format t "function POWER-REC~%") 
(defun power-rec (n m)
	(if (= m 1)
		n
		(* N (power-rec n (- m 1)))
	)
)

; Versione iterativa (usando loop - non quello che chiedeva il TEs!)
(format t "function POWER-ITER-LOOP~%")
(defun power-iter-loop (n m)
	(let ((m-temp m) (parziale 1))
		(loop
			(setq parziale (* parziale n))
			(setq m-temp (- m-temp 1))
			(when (= m-temp 0)
				(return parziale)
			)
		)
	)
)

(format t "function POWER-ITER~%")
(defun power-iter (n m)
	(do ((contatore m (- contatore 1)) (parziale 1 (* parziale n)))
		((= contatore 0) parziale)
	)
)

	
