;; Unifica.lsp by MacMan 16/7/2002
;; Unificatore semplificato
;; (vd. esercizio 10 TEs 18/2/1999)

;; Cosa fa?
;; Date due formule del tipo: (funzione1 variabile A) e
;; (funzione2 B variabile), restituisce la sostituzione che
;; unifica le due espressioni, se esiste, altrimenti NIL.
;; es:
;; > (unifica (ama "Giulietta" A) (ama B "Romeo"))
;; ((A "Romeo") (B "Giulietta"))
;; > (unifica (ama "Qualcuno" A) (odia B "Qualcunaltro"))
;; NIL

;; Nota: Non credo che sia perfettamente corretto cos!!!

(format t "unifica.lsp by MacMan 16/7/2002")

(defun unifica (termine1 termine2)
	; Per capirci, stabiliamo questa convenzione:
	; termine1 = (funzione1 x1 A)
	; termine2 = (funzione2 B x2)
	; Per prima cosa: se funzione1 e funzione2 non sono uguali
	; non esiste una possibile unificazione
	(let (
			(funzione1 (first termine1))
			(funzione2 (first termine2))
			(x1 (first (rest termine1)))
			(x2 (first (rest (rest termine2))))
		)
		(if (equal funzione1 funzione2)
			(list (list 'A x2) (list 'B x1))
			NIL
		)
	)
)
